package ru.yandex.common.abt;

import java.lang.ref.PhantomReference;
import java.lang.ref.ReferenceQueue;

/**
 * @author conterouz
 */
public class AbtFinalizer extends PhantomReference<AbtWrapper> {
    final Abt abt;
    public AbtFinalizer(AbtWrapper referent, ReferenceQueue<? super AbtWrapper> q) {
        super(referent, q);
        abt = referent.abt;
    }

    public void close() {
        if (abt.isAllocated()) {
            System.err.println("Cleaning Abt reference");
            abt.delete();
        }
    }
}
