#!/usr/bin/env perl

use strict;
use warnings;
use Requester;
use B;

sub user_request_hash {
    my $str = shift;
    $str =~ /&user_request=([^&]+)/;
    return hex B::hash($1);
}

sub print_request_result {
    my $result = shift;

    if ($result) {
        my $code = $result->StatusCode();
        print "  status: $code\n";
        my $body = $result->Content();
        print "  body:\n$body\n";
    } else {
        print "  no answer\n";
    }
}

my $request = "/wizard?do-not-adjust-client-params=1&lr=2&lr=2&pornfilter=1&rearr=Rabota_off;all_regions%3D2%2C10174%2C17%2C225%2C10001%2C10000;dc%3D1;dup%3D1;person;personalizeproduction;scheme_Local/Vertical/sport%3D%7Bsource%3A%22SPORT%22%2Cname%3A%22SPORT%22%2CNoNumber%3A%221%22%2CFake%3A%22sport.yandex.ru%22%2CIntentWeight%3A%221%22%2CRelevance%3A%22%28-1+*+%28f.SportBM25F+%3C+0.01%29%29+%2B+%280.5*%28f.SportBM25F+%3E+0%29%29%22%7D;scheme_blender/enabled%3D1&relev=&reqid=1373269858174057-06503-3-030&restrict=&restrict_config=&rloc=MSK&snip=reps%3Dall_on&text=test&tld=ru&uil=ru&user_request=test";

my $main_wizards_str = <<EOF;
{
    "Hosts" : "(ws11-446.yandex.ru:8891\@16 ws25-198.yandex.ru:8891\@16 ws17-164.yandex.ru:8891\@16 ws17-420.yandex.ru:8891\@16 ws14-382.yandex.ru:8891\@16 ws12-290.yandex.ru:8891\@16 ws17-329.yandex.ru:8891\@16 ws17-029.yandex.ru:8891\@16 ws24-130.yandex.ru:8891\@16 ws15-231.yandex.ru:8891\@16 ws11-444.yandex.ru:8891\@16 ws15-146.yandex.ru:8891\@16 ws17-108.yandex.ru:8891\@16 ws18-347.yandex.ru:8891\@16 ws24-237.yandex.ru:8891\@16 ws14-358.yandex.ru:8891\@16)\@256 (ws9-265.yandex.ru:8891\@16 ws7-282.yandex.ru:8891\@16 ws8-031.yandex.ru:8891\@16 ws9-074.yandex.ru:8891\@16 ws9-392.yandex.ru:8891\@16 ws9-452.yandex.ru:8891\@16 ws9-477.yandex.ru:8891\@16 ws8-117.yandex.ru:8891\@16 ws8-149.yandex.ru:8891\@16)\@144 (imgs28-111.yandex.ru:8891\@24 ws30-469.yandex.ru:8891\@24 ws29-252.yandex.ru:8891\@24 ws29-219.yandex.ru:8891\@24 imgs30-099.yandex.ru:8891\@24 ws28-240.yandex.ru:8891\@24 ws27-358.yandex.ru:8891\@24 imgs28-139.yandex.ru:8891\@24 ws31-375.yandex.ru:8891\@24 ws27-415.yandex.ru:8891\@24 ws30-000.yandex.ru:8891\@24 ws29-139.yandex.ru:8891\@24)\@288 (ws19-460.yandex.ru:8891\@16 ws19-050.yandex.ru:8891\@16 ws20-340.yandex.ru:8891\@16 ws23-249.yandex.ru:8891\@16 ws20-386.yandex.ru:8891\@16 ws22-429.yandex.ru:8891\@16 ws21-134.yandex.ru:8891\@16 ws21-332.yandex.ru:8891\@16 ws21-459.yandex.ru:8891\@16 ws22-440.yandex.ru:8891\@16 ws19-465.yandex.ru:8891\@16)\@176",
    "Delays" : "0 35ms",
    "TimeoutMilliseconds" : 100,
    "ReconnectTimeoutMilliseconds" : 70,
    "HostSelectionPolicy": "hhh",
    "RequestsCount" : 3
}
EOF

my $tdi_wizards_str = <<EOF;
{
    "Hosts" : "ws11-446.yandex.ru:8891\@16 ws25-198.yandex.ru:8891\@16",
    "Delays" : "0 35ms",
    "TimeoutMilliseconds" : 100,
    "ReconnectTimeoutMilliseconds" : 70,
    "HostSelectionPolicy": "hhh",
    "RequestsCount" : 2
}
EOF

my $main_wizards_param = Yx::RequesterConfig::requester_params_from_json($main_wizards_str);
my $tdi_wizards_param = Yx::RequesterConfig::requester_params_from_json($tdi_wizards_str);

my $c = Yx::ThreadContext::context_with_eventlog("eventlog.N", 1);
my $r = Yx::RemoteRequester->new($c, "test.pl");

my $main_id = $r->AddMultiRequest($main_wizards_param, $request);
$r->SetRequestHash($main_id, user_request_hash($request));
$r->SetDescription($main_id, "main remote wizard fetcher");

my $tdi_id = $r->AddMultiRequest($tdi_wizards_param, $request);
$r->SetRequestHash($tdi_id, user_request_hash($request));
$r->SetDescription($tdi_id, "tdi remote wizard fetcher");

$r->Start();
$r->Join();

print_request_result($r->GetRequestResult($main_id));
print_request_result($r->GetRequestResult($tdi_id));

print $r->GetEvents();
